[![Build & Verify](https://github.com/svenjacobs/leon/actions/workflows/build.yml/badge.svg)](https://github.com/svenjacobs/leon/actions/workflows/build.yml) [![Deploy](https://github.com/svenjacobs/leon/actions/workflows/deploy.yml/badge.svg)](https://github.com/svenjacobs/leon/actions/workflows/deploy.yml) <!-- ALL-CONTRIBUTORS-BADGE:START - Do not remove or modify this section -->
[![All Contributors](https://img.shields.io/badge/all_contributors-20-orange.svg?style=flat-square)](#contributors-)
<!-- ALL-CONTRIBUTORS-BADGE:END -->

**Léon - The URL Cleaner** is an Android application which removes tracking and other obsolete
parameters from a URL before sharing. Its usage is simple, integrating into Android's standard
sharing mechanism.

Léon runs on Android 5.0 and later, is open source and does not contain any tracking or advertising
frameworks. Léon does not collect any data about you.

The benefits of removing tracking parameters are:

- Protects your and the recipient's privacy
- Improves readability of links
- Saves characters (in Tweets for example)

## Installation

- [F-Droid](https://www.f-droid.org/packages/com.svenjacobs.app.leon/)
- [Google Play Store](https://play.google.com/store/apps/details?id=com.svenjacobs.app.leon)

## How to use

When sharing a link, select **URL Cleaner** as the receiving application. Then from within URL
Cleaner share the cleaned URL to the actual target application.

<img src="./app/src/main/res/drawable-nodpi/howto_pixel_5.webp" width="250" />

## Issues & feedback

Did you find a bug or have an idea of how the app could be improved? Please report
[bugs](https://github.com/svenjacobs/leon/issues) or give
[feedback](https://github.com/svenjacobs/leon/discussions).

## Technical implementation

This app is also meant as a blueprint for modern Android development, presenting and evaluating
recommended and cutting-edge technologies, patterns and libraries such as:

- [Kotlin](https://kotlinlang.org/) programming language
- Kotlin [coroutines](https://kotlinlang.org/docs/coroutines-overview.html)
- Jetpack [Compose](https://developer.android.com/jetpack/compose)
- Jetpack [Navigation](https://developer.android.com/guide/navigation)
- [Material Design 3](https://m3.material.io/)
- Dependency Injection pattern with custom implementation
- several other Jetpack & AndroidX libraries

## Contributors

<!-- ALL-CONTRIBUTORS-LIST:START - Do not remove or modify this section -->
<!-- prettier-ignore-start -->
<!-- markdownlint-disable -->
<table>
  <tbody>
    <tr>
      <td align="center"><a href="http://svenjacobs.com"><img src="https://avatars.githubusercontent.com/u/255313?v=4?s=100" width="100px;" alt="Sven Jacobs"/><br /><sub><b>Sven Jacobs</b></sub></a><br /><a href="#maintenance-svenjacobs" title="Maintenance">🚧</a> <a href="https://github.com/svenjacobs/leon/commits?author=svenjacobs" title="Code">💻</a> <a href="https://github.com/svenjacobs/leon/commits?author=svenjacobs" title="Tests">⚠️</a> <a href="https://github.com/svenjacobs/leon/commits?author=svenjacobs" title="Documentation">📖</a> <a href="#ideas-svenjacobs" title="Ideas, Planning, & Feedback">🤔</a></td>
      <td align="center"><a href="http://meet.deekshith.in"><img src="https://avatars.githubusercontent.com/u/2568945?v=4?s=100" width="100px;" alt="Deekshith Allamaneni"/><br /><sub><b>Deekshith Allamaneni</b></sub></a><br /><a href="#ideas-adeekshith" title="Ideas, Planning, & Feedback">🤔</a></td>
      <td align="center"><a href="https://github.com/jimcarst"><img src="https://avatars.githubusercontent.com/u/37066510?v=4?s=100" width="100px;" alt="jimcarst"/><br /><sub><b>jimcarst</b></sub></a><br /><a href="#ideas-jimcarst" title="Ideas, Planning, & Feedback">🤔</a></td>
      <td align="center"><a href="http://openfoxblog.leven.dev"><img src="https://avatars.githubusercontent.com/u/39553804?v=4?s=100" width="100px;" alt="Damon Leven"/><br /><sub><b>Damon Leven</b></sub></a><br /><a href="#ideas-MCWertGaming" title="Ideas, Planning, & Feedback">🤔</a></td>
      <td align="center"><a href="https://github.com/EasyVector"><img src="https://avatars.githubusercontent.com/u/25502419?v=4?s=100" width="100px;" alt="Yuhui Su"/><br /><sub><b>Yuhui Su</b></sub></a><br /><a href="https://github.com/svenjacobs/leon/commits?author=EasyVector" title="Code">💻</a></td>
      <td align="center"><a href="https://github.com/bangzek"><img src="https://avatars.githubusercontent.com/u/5100725?v=4?s=100" width="100px;" alt="Zakaria"/><br /><sub><b>Zakaria</b></sub></a><br /><a href="#ideas-bangzek" title="Ideas, Planning, & Feedback">🤔</a></td>
      <td align="center"><a href="https://github.com/pludi"><img src="https://avatars.githubusercontent.com/u/2112148?v=4?s=100" width="100px;" alt="Peter L."/><br /><sub><b>Peter L.</b></sub></a><br /><a href="#ideas-pludi" title="Ideas, Planning, & Feedback">🤔</a></td>
    </tr>
    <tr>
      <td align="center"><a href="https://github.com/jaswinder77"><img src="https://avatars.githubusercontent.com/u/31370528?v=4?s=100" width="100px;" alt="jaswinder77"/><br /><sub><b>jaswinder77</b></sub></a><br /><a href="#ideas-jaswinder77" title="Ideas, Planning, & Feedback">🤔</a></td>
      <td align="center"><a href="https://www.onnno.nl/"><img src="https://avatars.githubusercontent.com/u/31142286?v=4?s=100" width="100px;" alt="Donno"/><br /><sub><b>Donno</b></sub></a><br /><a href="#ideas-Donnnno" title="Ideas, Planning, & Feedback">🤔</a></td>
      <td align="center"><a href="https://github.com/slootsky"><img src="https://avatars.githubusercontent.com/u/5387861?v=4?s=100" width="100px;" alt="slootsky"/><br /><sub><b>slootsky</b></sub></a><br /><a href="#ideas-slootsky" title="Ideas, Planning, & Feedback">🤔</a> <a href="https://github.com/svenjacobs/leon/issues?q=author%3Aslootsky" title="Bug reports">🐛</a></td>
      <td align="center"><a href="https://www.rakuten.com/r/TPSAMU?eeid=6991100"><img src="https://avatars.githubusercontent.com/u/185902?v=4?s=100" width="100px;" alt="TPS"/><br /><sub><b>TPS</b></sub></a><br /><a href="#ideas-TPS" title="Ideas, Planning, & Feedback">🤔</a> <a href="https://github.com/svenjacobs/leon/issues?q=author%3ATPS" title="Bug reports">🐛</a></td>
      <td align="center"><a href="https://github.com/Enkidu70"><img src="https://avatars.githubusercontent.com/u/1456895?v=4?s=100" width="100px;" alt="Robert"/><br /><sub><b>Robert</b></sub></a><br /><a href="#ideas-Enkidu70" title="Ideas, Planning, & Feedback">🤔</a></td>
      <td align="center"><a href="http://cooper-davis.net"><img src="https://avatars.githubusercontent.com/u/8947634?v=4?s=100" width="100px;" alt="Ari Cooper Davis"/><br /><sub><b>Ari Cooper Davis</b></sub></a><br /><a href="#ideas-aricooperdavis" title="Ideas, Planning, & Feedback">🤔</a> <a href="https://github.com/svenjacobs/leon/commits?author=aricooperdavis" title="Code">💻</a> <a href="https://github.com/svenjacobs/leon/commits?author=aricooperdavis" title="Tests">⚠️</a></td>
      <td align="center"><a href="https://github.com/ChristopherKing42"><img src="https://avatars.githubusercontent.com/u/8742930?v=4?s=100" width="100px;" alt="Christopher King"/><br /><sub><b>Christopher King</b></sub></a><br /><a href="#ideas-ChristopherKing42" title="Ideas, Planning, & Feedback">🤔</a></td>
    </tr>
    <tr>
      <td align="center"><a href="https://github.com/chel1k"><img src="https://avatars.githubusercontent.com/u/70620574?v=4?s=100" width="100px;" alt="chel1k"/><br /><sub><b>chel1k</b></sub></a><br /><a href="#translation-chel1k" title="Translation">🌍</a></td>
      <td align="center"><a href="https://github.com/slmb3"><img src="https://avatars.githubusercontent.com/u/80601335?v=4?s=100" width="100px;" alt="slmb3"/><br /><sub><b>slmb3</b></sub></a><br /><a href="#ideas-slmb3" title="Ideas, Planning, & Feedback">🤔</a></td>
      <td align="center"><a href="https://github.com/aha999"><img src="https://avatars.githubusercontent.com/u/50620416?v=4?s=100" width="100px;" alt="Klemen Skerbiš"/><br /><sub><b>Klemen Skerbiš</b></sub></a><br /><a href="#ideas-aha999" title="Ideas, Planning, & Feedback">🤔</a></td>
      <td align="center"><a href="https://github.com/chexxor"><img src="https://avatars.githubusercontent.com/u/843161?v=4?s=100" width="100px;" alt="Alex Berg"/><br /><sub><b>Alex Berg</b></sub></a><br /><a href="#ideas-chexxor" title="Ideas, Planning, & Feedback">🤔</a></td>
      <td align="center"><a href="https://github.com/osjasmine"><img src="https://avatars.githubusercontent.com/u/86544869?v=4?s=100" width="100px;" alt="osjasmine"/><br /><sub><b>osjasmine</b></sub></a><br /><a href="https://github.com/svenjacobs/leon/issues?q=author%3Aosjasmine" title="Bug reports">🐛</a></td>
      <td align="center"><a href="https://github.com/guerda"><img src="https://avatars.githubusercontent.com/u/230782?v=4?s=100" width="100px;" alt="Philip Gillißen"/><br /><sub><b>Philip Gillißen</b></sub></a><br /><a href="https://github.com/svenjacobs/leon/issues?q=author%3Aguerda" title="Bug reports">🐛</a> <a href="#ideas-guerda" title="Ideas, Planning, & Feedback">🤔</a> <a href="https://github.com/svenjacobs/leon/commits?author=guerda" title="Code">💻</a> <a href="https://github.com/svenjacobs/leon/commits?author=guerda" title="Tests">⚠️</a></td>
    </tr>
  </tbody>
</table>

<!-- markdownlint-restore -->
<!-- prettier-ignore-end -->

<!-- ALL-CONTRIBUTORS-LIST:END -->
<!-- prettier-ignore-start -->
<!-- markdownlint-disable -->

<!-- markdownlint-restore -->
<!-- prettier-ignore-end -->

<!-- ALL-CONTRIBUTORS-LIST:END -->
